# মেসেজ পরিসংখ্যান

## messages:list

পাঠানো মেসেজগুলোর তালিকা প্রদর্শন করে।

`POST` `https://api.pushwoosh.com/api/v2/messages:list`

##### হেডারসমূহ

| নাম    <div style="width:200px"></div>        | আবশ্যক <div style="width:100px"></div>| বিবরণ  <div style="width:150px"></div>                                                                                        |
|----------------|----------|------------------------------------------------------------------------------------------------------|
| `Authorization`| হ্যাঁ      | [Server API token](/bn/developer/api-reference/api-access-token/#server-api-token)। এটি অবশ্যই নিম্নলিখিত ফরম্যাটে প্রদান করতে হবে: `Authorization: Api <Server Key>`।     |

##### রিকোয়েস্ট বডি প্যারামিটার

| নাম <div style="width:150px"></div> | আবশ্যক <div style="width:100px"></div> | ধরণ <div style="width:100px"></div> | বিবরণ <div style="width:150px"></div> |
|--------------------------------------|----------|---------|--------------------------------------------------------------------------------------------------------------------------------|
| `platforms`                         | না       | Array   | মেসেজ প্ল্যাটফর্ম। সম্ভাব্য মানসমূহ: `"IOS"`, `"ANDROID"`, `"OSX"`, `"WINDOWS"`, `"AMAZON"`, `"SAFARI"`, `"CHROME"`, `"FIREFOX"`, `"IE"`, `"EMAIL"`, `"HUAWEI_ANDROID"`, `"SMS"`।                                                           |
| `date_range`                         | না       | Object  | রিপোর্টিং পিরিয়ড। `date_from` এবং `date_to` অবশ্যই `YYYY-MM-DD` ফরম্যাট অনুসরণ করতে হবে (যেমন, `"2000-01-01"`)।                                                                  |
| `campaign`                           | না       | String  | [ক্যাম্পেইন কোড](/bn/developer/api-reference/api-identifiers/#campaign-code)                                                                                                               |
| `filters`                            | হ্যাঁ      | Object  | মেসেজ ফিল্টার।                                                                                                          |
| `source`                             | না       | String  | মেসেজ সোর্স। উদাহরণস্বরূপ: `AB_TEST`, `API`, `AUTO_PUSH`, `CP`, `CSV`, `CUSTOMER_JOURNEY`, `EMAIL_API`, `EMAIL_CP`, `GEO_ZONE`, `PUSH_ON_EVENT`, `RSS`।                                                             |
| `messages_codes`                     | না       | Array   | `/createMessage` API রেসপন্স থেকে প্রাপ্ত [মেসেজ কোড](/bn/developer/api-reference/api-identifiers/#message-code)।                                                                                                               |
| `messages_ids`                       | না       | Array   | মেসেজ হিস্ট্রি থেকে প্রাপ্ত মেসেজ আইডি।                                                                                                                |
| `params`                             | না       | Object  | মেসেজের বিবরণ এবং মেট্রিক্স দেখানো হবে কিনা তা নির্দিষ্ট করুন। রেসপন্সে `"details"` অবজেক্ট অন্তর্ভুক্ত করতে `with_details: true` এবং `"metrics"` অবজেক্ট অন্তর্ভুক্ত করতে `with_metrics: true` সেট করুন।                               |
| `application`                        | হ্যাঁ      | String  | [Pushwoosh অ্যাপ্লিকেশন কোড](/bn/developer/api-reference/api-identifiers/#application-code)।                                                                                                  |
| `per_page`                           | না       | Integer | প্রতি পৃষ্ঠায় ফলাফলের সংখ্যা (≤ 1000)।                                                                                         |
| `page`                               | না       | Integer | পেজিনেশনের জন্য পৃষ্ঠা নম্বর।                                                                                                  |


##### উদাহরণ রিকোয়েস্ট

```
{
    "filters": {
      "platforms": [],                  // IOS, ANDROID, OSX, WINDOWS, AMAZON, SAFARI, CHROME, FIREFOX, IE, EMAIL, HUAWEI_ANDROID, SMS
      "date_range": {
        "date_from": "string",          // Required format: 2000-01-01
        "date_to": "string"             // Required format: 2000-01-01
      },
      "source": "API",                  // AB_TEST, API, AUTO_PUSH, CP, CSV, CUSTOMER_JOURNEY, EMAIL_API, EMAIL_CP, GEO_ZONE, PUSH_ON_EVENT, RSS
      "campaign": "string",             // Campaign code
      "messages_ids": [],               // Message IDs
      "messages_codes": [],             // Message codes
      "application": "string"           // Pushwoosh application code
    },
    "params": {
      "with_details": true,             // Add message details to the response ("details" object)
      "with_metrics": true              // Add message metrics to the response ("metrics" object)
    },
    "per_page": 20,                     // <= 1000
    "page": 0
}
```

 <details>
  <summary> রেসপন্স কোড এবং উদাহরণ </summary>
<Tabs>
<TabItem label="200: OK">
```
{
  "total": 0,
  "items": [{
    "id": 0,
    "code": "string",
    "created_date": "string",
    "send_date": "string",
    "status": "string",
    "platforms": [],
    "source": "string",
    "push_info": {
      "details": {
        "title": "string",
        "filter_name": "string",
        "filter_code": "string",
        "content": {
          "key": "value"
        },
        "platform_parameters": {
          "android_header": "string",
          "android_root_params": {
            "key": "value"
          },
          "ios_title": "string",
          "ios_subtitle": "string",
          "ios_root_params": {
            "key": "value"
          },
          "chrome_header": "string",
          "chrome_root_params": {
            "key": "value"
          },
          "firefox_header": "string",
          "firefox_root_params": {
            "key": "value"
          },
          "conditions": [               // tag conditions (see /developer/api-reference/messages-api/#tag-conditions)
            TAG_CONDITION1,
            TAG_CONDITION2,
            ...,
            TAG_CONDITIONN
          ],
          "conditions_operator": "AND", // logical operator for conditions arrays; possible values: AND, OR
          "data": {
            "key": "value"
          }
        },
        "follow_user_timezone": true
      },
      "metrics": [{
        "sends": 0,
        "opens": 0,
        "deliveries": 0,
        "inbox_opens": 0,
        "unshowable_sends": 0,
        "errors": 0,
        "platform": 0
      }]
    },
    "email_info": {
      "details": {
        "template": "string",
        "filter_name": "string",
        "filter_code": "string",
        "subject": {
          "key": "value"
        },
        "from_name": "string",
        "from_email": "string",
        "reply_name": "string",
        "reply_email": "string",
        "follow_user_timezone": true,
        "conditions": [              // tag conditions (see Messages-api - tag-conditions) 
          TAG_CONDITION1,
          TAG_CONDITION2,
          ...,
          TAG_CONDITIONN
        ],  
        "conditions_operator": "AND" // logical operator for conditions arrays; possible values: AND, OR
      },
      "metrics": [{
        "sends": 0,
        "opens": 0,
        "deliveries": 0,
        "hard_bounces": 0,
        "soft_bounces": 0,
        "rejects": 0,
        "confirmed_sends": 0,
        "unsubs": 0,
        "complaints": 0,
        "errors": 0
      }]
    }
  }]
}
```
</TabItem>

<TabItem label="400: Bad Request Error">
```json
{
  "error": "exceeded the maximum date interval. Max interval: 30 days"
}
```
</TabItem>

<TabItem label="401: Incorrect API access token">
```json
{
  "error": "account not found"
}
```
</TabItem>

<TabItem label="500: Internal Server Error">

</TabItem>
</Tabs>

</details>


<Aside type="note">
iOS-এর জন্য, অনুগ্রহ করে নিশ্চিত করুন যে আপনি পুশ ডেলিভারি ট্র্যাক করার জন্য আপনার প্রজেক্টে Notification Service Extension যোগ করেছেন। [আরও জানুন](/bn/developer/pushwoosh-sdk/ios-sdk/ios-message-delivery-tracking)
</Aside>

## totalsByIntervals

মেসেজ কোডের উপর ভিত্তি করে মেট্রিক্স এবং কনভার্সন ডেটা প্রদান করে, যা ঘন্টা অনুযায়ী একত্রিত করা হয়।

**POST** `https://api.pushwoosh.com/api/v2/statistics/messages/totalsByIntervals`
  

##### অথরাইজেশন

রিকোয়েস্ট হেডারে API Access Token-এর মাধ্যমে অথরাইজেশন পরিচালনা করা হয়।

##### রিকোয়েস্ট বডি প্যারামিটার

| প্যারামিটারের নাম  <div style="width:150px"></div>   | ধরণ   <div style="width:150px"></div>   | বিবরণ                 | আবশ্যক |
|----------------|--------|-----------------------------|----------|
| `message_code` | string | `/createMessage` API রেসপন্স থেকে প্রাপ্ত [মেসেজ কোড](/bn/developer/api-reference/api-identifiers/#message-code)।    | হ্যাঁ      |
| `platforms`    | [int]  | [প্ল্যাটফর্মসমূহ](/bn/developer/api-reference/messages-api/api-prerequisites/#platforms)                    | না       |

##### রিকোয়েস্টের উদাহরণ

```
{
  "message_code": "XXXXX-XXXXXXXXX-XXXXXXXX", // required. Unique message identifier
  "platforms": [1, 3, 7, 10, 11, 12]          // optional. List of platform codes
}
```

##### রেসপন্স ফিল্ডসমূহ

| নাম              | ধরণ   | বিবরণ                                                       |
|-------------------|--------|-------------------------------------------------------------------|
|  **`metrics`**         | **array**  | **মেসেজ মেট্রিক্সের একটি অ্যারে ধারণ করে**                              |
|    `timestamp`       | string | মেট্রিকের সময়।                                           |
|    `platform`        | int    | প্ল্যাটফর্ম কোড (যেমন, iOS, Android)।                           |
| `sends`           | string | পাঠানো মেসেজের সংখ্যা।                                      |
| `opens`           | string | খোলা মেসেজের সংখ্যা।                                    |
| `deliveries`      | string | ডেলিভার হওয়া মেসেজের সংখ্যা।                                 |
| `inbox_opens`     | string | ইনবক্স খোলার সংখ্যা।                                        |
| `unshowable_sends`| string | পাঠানো মেসেজের সংখ্যা যা দেখানো সম্ভব হয়নি।              |
| `errors`          | string | ত্রুটির সংখ্যা।                                             |
| **`conversion`**      | **object** | **কনভার্সন ডেটা ধারণ করে**                                          |
| `sends`           | string | পাঠানো মেসেজের মোট সংখ্যা।                                |
| `opens`           | string | খোলা মেসেজের মোট সংখ্যা।                              |
| **`events`**          | **array**  | **পরিসংখ্যান সহ ইভেন্টগুলোর একটি অ্যারে**                         |
| `name`            | string | ইভেন্টের নাম (যেমন, cart add)।                           |
| `hits`            | string | হিটের সংখ্যা।                                               |
| `conversion`      | float  | ওপেনের সাপেক্ষে কনভার্সন রেট।                            |
| `revenue`         | float  | রেভিনিউ (শুধুমাত্র `__amount` এবং `__currency` অ্যাট্রিবিউট সহ ইভেন্টগুলোর জন্য)। |

##### রেসপন্সের উদাহরণ

```
{
  "metrics": [{
    "timestamp": "2024-08-03 15:00:00",  // Timestamp of the metrics in "YYYY-MM-DD HH:MM:SS" format
    "platform": 3,                       // Platform code
    "sends": "55902",                    // Number of messages sent
    "opens": "382",                      // Number of messages opened
    "deliveries": "22931",               // Number of messages delivered
    "inbox_opens": "0",                  // Number of messages opened in the inbox
    "unshowable_sends": "2",             // Number of messages that couldn't be shown
    "errors": "0"                        // Number of errors encountered
  }],
  "conversion": {
    "sends": "55902",                    // Total number of messages sent
    "opens": "772",                      // Total number of messages opened
    "events": [{
      "name": "cart_add",                // Name of the event
      "hits": "96",                      // Number of hits for the event
      "conversion": 0.12,                // Conversion rate relative to opens
      "revenue": 0                       // Revenue generated by the event (only for events with amount/currency attributes)
    }]
  }
}
```

## getMessageLog

পাঠানো মেসেজগুলো সম্পর্কে বিস্তারিত তথ্য প্রদর্শন করে।

`POST` `https://api.pushwoosh.com/api/v2/statistics/getMessageLog`

##### হেডারসমূহ


| নাম   <div style="width:150px"></div>              | আবশ্যক <div style="width:150px"></div>    |  বিবরণ    <div style="width:150px"></div>                                                                                                             |
|-----------------|----------|----------------------------------------------------------------------------------------------------------------------------|
| `Authorization` | আবশ্যক | Pushwoosh কন্ট্রোল প্যানেল থেকে প্রাপ্ত [API access token](/bn/developer/api-reference/api-access-token/)। |


##### রিকোয়েস্ট বডি প্যারামিটার

| নাম    <div style="width:150px"></div>            | আবশ্যক <div style="width:80px"></div>      | ধরণ   <div style="width:100px"></div>              | বিবরণ       <div style="width:150px"></div>                                                                                                                                                                                               |
|--------------------|------------------|----------------|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| `message_id`       | না        | Integer         | মেসেজ হিস্ট্রি থেকে প্রাপ্ত Message ID দ্বারা মেসেজ ইভেন্ট নির্বাচন করুন। উদাহরণ: `12345678900`।                                                                                                               |
| `message_code`     | না         | String          | `/createMessage` API রেসপন্স থেকে প্রাপ্ত [মেসেজ কোড](/bn/developer/api-reference/api-identifiers/#message-code) দ্বারা মেসেজ ইভেন্ট নির্বাচন করুন। উদাহরণ: `"A444-AAABBBCC-00112233"`।                                                                                |
| `campaign_code`    | না         | String          | আপনার মেসেজ পেলোডে নির্দিষ্ট করা [ক্যাম্পেইন কোড](/bn/developer/api-reference/api-identifiers/#campaign-code) দ্বারা মেসেজ ইভেন্ট নির্বাচন করুন। উদাহরণ: `"AAAAA-XXXXX"`।                                                                                                      |
| `hwid`            | না          | String or Array  | [HWID (হার্ডওয়্যার আইডি)](/bn/developer/api-reference/api-identifiers/#hardware-id) বা HWID-এর একটি অ্যারে দ্বারা মেসেজ ইভেন্ট নির্বাচন করুন।                                                                                                                                        |
| `date_from`       | আবশ্যক যদি `message_id`, `message_code`, বা `campaign_code` প্রদান না করা হয় | Datetime        | মেসেজ ফিল্টার করার শুরুর তারিখ। ফরম্যাট: `"YYYY-MM-DD HH:MM:SS"`। উদাহরণ: `"2000-01-25 00:00:00"`।                                                                                                   |
| `date_to`         | আবশ্যক যদি `message_id`, `message_code`, বা `campaign_code` প্রদান না করা হয় | Datetime        | মেসেজ ফিল্টার করার শেষ তারিখ। ফরম্যাট: `"YYYY-MM-DD HH:MM:SS"`। উদাহরণ: `"2000-01-26 00:00:00"`।                                                                                                     |
| `limit`           | না        | Integer         | একটি একক রেসপন্সে ফেরত আসা মেসেজ ইভেন্টের সর্বোচ্চ সংখ্যা। সর্বোচ্চ মান: `100000`।                                                                                                                 |
| `pagination_token` | না         | String         | পূর্ববর্তী `/getMessageLog` রেসপন্স থেকে প্রাপ্ত পেজিনেশন টোকেন। অতিরিক্ত ফলাফল পুনরুদ্ধার করতে এটি ব্যবহার করুন।                                                                                              |
| `user_id`         | না          | String          | একটি কাস্টম [User ID](/bn/developer/api-reference/api-identifiers/#user-id) দ্বারা মেসেজ ইভেন্ট নির্বাচন করুন। আরও বিস্তারিত জানার জন্য `/registerUser` দেখুন।                                                                                                                        |
| `application_code` | হ্যাঁ        | String          | [Pushwoosh অ্যাপ্লিকেশন কোড](/bn/developer/api-reference/api-identifiers/#application-code) দ্বারা মেসেজ ইভেন্ট নির্বাচন করুন।                                                                                                                                                |
| `actions`         | না         | Array           | নির্দিষ্ট মেসেজ অ্যাকশন দ্বারা ফলাফল ফিল্টার করুন। সম্ভাব্য মানসমূহ: `"sent"`, `"delivered"`, `"opened"`, `"inbox_delivered"`, `"inbox_read"`, `"inbox_opened"`, `"inbox_deleted"`।                           |
| `platforms`       | না         | Array           | ফলাফল ফিল্টার করার জন্য টার্গেট প্ল্যাটফর্মের অ্যারে। সম্ভাব্য মানসমূহ: `"ios"`, `"android"`, `"osx"`, `"windows"`, `"amazon"`, `"safari"`, `"chrome"`, `"firefox"`, `"ie"`, `"email"`, `"huawei_android"`।     |

##### উদাহরণ রিকোয়েস্ট
```
curl --location --request POST 'https://api.pushwoosh.com/api/v2/statistics/getMessageLog' \
--header 'Authorization: Key API_ACCESS_TOKEN' \
--header 'Content-Type: application/json' \
--data-raw '{
   "pagination_token": "PAGINATION_TOKEN_FROM_PREVIOUS_RESPONSE",  // optional, token for pagination
   "limit": 1000,                                  // optional, the max number of entries for a single response
   "application_code": "XXXXX-XXXXX",              // Pushwoosh app code
   "message_code": "A444-AAABBBCC-00112233",       // optional, message code obtained from /createMessaage request
   "message_id": 1234567890,                       // optional, message ID obtained from Pushwoosh Control Panel
   "campaign_code": "AAAAA-XXXXX",                 // optional, code of a campaign to get the log for
   "hwid": "aaazzzqqqqxxx",                        // optional, hardware ID of a specific device targeted with a message
   "user_id": "user_123",                          // optional, ID of a user targeted with the message
   "date_from": "2000-01-25 00:00:00",             // optional, start of the stats period 
   "date_to": "2000-02-10 23:59:59",               // optional, end of the stats period
   "actions": ["opened", "inbox_opened"],          // optional, used for results filtration. Possible values: "sent", "opened", "delivered", "inbox_delivered", "inbox_read", "inbox_opened", "inbox_deleted". The response will include all the messages with the specified action(s).
   "platforms": ["ios", "chrome"]                  // optional, used for results filtration. Possible values: "ios", "android", "osx", "windows", "amazon", "safari", "chrome", "firefox", "ie", "email", "huawei android"
}'
```


<Aside type="caution" title="গুরুত্বপূর্ণ">
নিম্নলিখিত ফিল্ডগুলোর মধ্যে একটি আবশ্যক:\
\- _message\_id_\
_- message\_code_\
_- campaign\_code_\
_- hwid_\
_- user\_id_\
_- date\_from_ এবং _date\_to_

আপনার মেসেজ পরিসংখ্যান থেকে সর্বাধিক সুবিধা পেতে বিভিন্ন ফিল্টারিং প্যারামিটার প্রয়োগ করার কথা বিবেচনা করুন।
</Aside>

<details>
  <summary> রেসপন্স কোড এবং উদাহরণ </summary>
<Tabs>
<TabItem label="200: OK">
```json
{
  "pagination_token": "PAGINATION_TOKEN_FOR_NEXT_REQUEST",
  "data": [{
    "timestamp": "2000-01-25T11:18:47Z",
    "application_code": "XXXXX-XXXXX",
    "message_id": 12345678900,
    "message_code": "A444-AAABBBCC-00112233",
    "campaign_code": "AAAAA-XXXXX",
    "hwid": "aaazzzqqqqxxx",
    "user_id": "user_123",
    "platform": "android",
    "action": "sent",
    "status": "success",
    "push_alerts_enabled": "true"
  }, {
    "timestamp": "2000-01-25T11:18:49Z",
    "application_code": "XXXXX-XXXXX",
    "message_id": 12345678900,
    "message_code": "A444-AAABBBCC-00112233",
    "campaign_code": "AAAAA-XXXXX",
    "hwid": "aaazzzqqqqxxx",
    "user_id": "user_123",
    "platform": "android",
    "action": "delivered",
    "push_alerts_enabled": "true"
  }, {
    "timestamp": "2000-01-25T11:19:23Z",
    "application_code": "XXXXX-XXXXX",
    "message_id": 12345678900,
    "message_code": "A444-AAABBBCC-00112233",
    "campaign_code": "AAAAA-XXXXX",
    "hwid": "aaazzzqqqqxxx",
    "user_id": "user_123",
    "platform": "android",
    "action": "opened",
    "push_alerts_enabled": "true"
  }]
}
```
</TabItem>

<TabItem label="400: Bad Request">
```json
{
  "error": "exceeded the maximum date interval. Max interval: 30 days"
}
```
</TabItem>

<TabItem label="401: Unauthorized">
```json
{
  "error": "account not found"
}
```
</TabItem>

<TabItem label="500: Internal Server Error">

</TabItem>
</Tabs>

</details>



<Aside type="note">
বর্তমান সময় থেকে সর্বোচ্চ ৩০ দিন পর্যন্ত ডেটা ডাউনলোড করা যেতে পারে।
</Aside>


<Aside type="tip">
iOS-এর জন্য, অনুগ্রহ করে নিশ্চিত করুন যে আপনি পুশ ডেলিভারি ট্র্যাক করার জন্য আপনার প্রজেক্টে Notification Service Extension যোগ করেছেন। [আরও জানুন](/bn/developer/pushwoosh-sdk/ios-sdk/ios-message-delivery-tracking)
</Aside>

## ইমেইল পরিসংখ্যান

### linksInteractions

ইমেইলে লিঙ্কে ক্লিকের পরিসংখ্যান প্রদর্শন করে।

`POST` `https://api.pushwoosh.com/api/v2/statistics/emails/linksInteractions`


##### হেডারসমূহ

| নাম    <div style="width:200px"></div>         | আবশ্যক <div style="width:100px"></div> | বিবরণ                                                                                          |
|-----------------|----------|-------------------------------------------------------------------------------------------------------|
| `Authorization` | হ্যাঁ      | Pushwoosh কন্ট্রোল প্যানেল থেকে প্রাপ্ত [API access token](/bn/developer/api-reference/api-access-token/)।        |

##### রিকোয়েস্ট বডি প্যারামিটার

| নাম    <div style="width:200px"></div>            | আবশ্যক  <div style="width:50px"></div> |  ধরণ | বিবরণ                                                                                          |
|--------------------|----------|--------|------------------------------------------------------------------------------------------------------|
| `date_range`       | না       | Object | রিপোর্টিং পিরিয়ড সংজ্ঞায়িত করে। `date_from` এবং `date_to` ধারণ করে।                                   |
| `filters`          | হ্যাঁ      | Object | ইমেইল ফিল্টার।                                                                                      |
| `application`      | হ্যাঁ      | String | [Pushwoosh অ্যাপ্লিকেশন কোড](/bn/developer/api-reference/api-identifiers/#application-code) (বিকল্পভাবে, `campaign`, `messages_ids`, বা `message_codes` উল্লেখ করুন)। |
| `messages_codes`   | হ্যাঁ      | Array  | [মেসেজ কোড](/bn/developer/api-reference/api-identifiers/#message-code) (বিকল্পভাবে, `application`, `campaign`, বা `messages_ids` উল্লেখ করুন)।                |
| `campaign`        | হ্যাঁ      | String | [ক্যাম্পেইন কোড](/bn/developer/api-reference/api-identifiers/#campaign-code) (বিকল্পভাবে, `application`, `messages_ids`, বা `message_codes` উল্লেখ করুন)।           |
| `messages_ids`     | হ্যাঁ      | Array  | মেসেজ আইডি (বিকল্পভাবে, `application`, `campaign`, বা `message_codes` উল্লেখ করুন)।                 |
| `link_template`    | আবশ্যক যদি `application` বা `campaign` উল্লেখ করা হয়।     | String  | কীওয়ার্ড দ্বারা ইমেইল লিঙ্ক ইন্টারঅ্যাকশন ফিল্টার করে। শুধুমাত্র সেই লিঙ্কগুলো API রেসপন্সে ফেরত আসবে যাদের URL-এ নির্দিষ্ট টেক্সট অন্তর্ভুক্ত আছে। উদাহরণস্বরূপ, যদি আপনার ইমেইলে `https://example.com/news` এবং `https://example.com/shop`-এর মতো লিঙ্ক থাকে, তবে "link_template": "shop" সেট করলে শুধুমাত্র `https://example.com/shop`-এর জন্য ইন্টারঅ্যাকশন ফেরত আসবে।   |
| `email_content_code`        | না       | String | [ইমেইল কন্টেন্টের জন্য অনন্য শনাক্তকারী](/bn/developer/api-reference/api-identifiers/#email-content-code)।                                                                               |
| `params`          | না       | Object | অতিরিক্ত রেসপন্স অপশন সংজ্ঞায়িত করে। `with_full_links` অন্তর্ভুক্ত করে, যা পরিসংখ্যান সহ সম্পূর্ণ লিঙ্কের একটি তালিকা যোগ করে। |

##### রিকোয়েস্টের উদাহরণ

```
curl --location --request POST 'https://api.pushwoosh.com/api/v2/statistics/emails/linksInteractions' \
--header 'Authorization: Api API_ACCESS_TOKEN' \
--header 'Content-Type: application/json' \
--data-raw '{
   "filters": {
      "date_range": {
         "date_from": "string",           // Required format: 2000-01-01
         "date_to": "string"              // Required format: 2000-01-01
      },
      "campaign": "string",               // Campaign code (you can specify application, messages_ids, or message_codes instead)
      "application": "string",            // Application code (you can specify campaign, messages_ids, or message_codes instead)
      "messages_ids": [],                 // Message IDs (you can specify application, campaign, or message_codes instead)
      "messages_codes": [],               // Message codes (you can specify application, campaign, or message_ids instead)
      "link_template": "string",          // Link template (required if application or campaign is specified)
      "email_content_code": "string"      // Unique identifier for the email content.
   },
   "params": {
      "with_full_links": true             // Specify whether to show detailed statistics. A list of full links with statistics will be passed in the full_links array.
   }
}'
``` 

##### রেসপন্স কোড এবং উদাহরণ 
<Tabs>
<TabItem label="200: OK">
```json
{
  "items": [{
    "template": "string",
    "link": "string",
    "title": "string",
    "clicks": 0,
    "full_links": [{
      "full_link": "string",
      "clicks": 0
    }]
  }]
}
```
</TabItem>

<TabItem label="400: Bad Request">
```json
{
  "error": "exceeded the maximum date interval. Max interval: 30 days"
}
```
</TabItem>

<TabItem label="401: Unauthorized">
```json
{
  "error": "account not found"
}
```
</TabItem>

<TabItem label="500: Internal Server Error ">

</TabItem>
</Tabs>



### linksInteractionsDevices

ইমেইলে লিঙ্কে ক্লিক করা ব্যবহারকারীদের দেখায়।

`POST` `https://api.pushwoosh.com/api/v2/statistics/emails/linksInteractionsDevices`


##### হেডারসমূহ

| নাম  <div style="width:150px"></div>            | আবশ্যক <div style="width:100px"></div> | বিবরণ                                                                                          |
|-----------------|----------|------------------------------------------------------------------------------------------------------|
| `Authorization` | হ্যাঁ      | Pushwoosh কন্ট্রোল প্যানেল থেকে প্রাপ্ত [API access token](/bn/developer/api-reference/api-access-token/)।    |



##### রিকোয়েস্ট বডি প্যারামিটার

| নাম    <div style="width:150px"></div>            | আবশ্যক  <div style="width:100px"></div> | ধরণ    | বিবরণ                                                                                          |
|--------------------|----------|---------|------------------------------------------------------------------------------------------------------|
| `date_range`       | না       | Object  | রিপোর্টিং পিরিয়ড সংজ্ঞায়িত করে। `date_from` এবং `date_to` ধারণ করে।                                   |
| `filters`          | হ্যাঁ      | Object  | ইমেইল ফিল্টার।                                                                                      |
| `application`      | হ্যাঁ      | String  | [Pushwoosh অ্যাপ্লিকেশন কোড](/bn/developer/api-reference/api-identifiers/#application-code) (বিকল্পভাবে, `campaign`, `messages_ids`, বা `message_codes` উল্লেখ করুন)। |
| `messages_codes`   | হ্যাঁ      | Array   | [মেসেজ কোড](/bn/developer/api-reference/api-identifiers/#message-code) (বিকল্পভাবে, `application`, `campaign`, বা `messages_ids` উল্লেখ করুন)।                |
| `campaign`         | হ্যাঁ      | String  | [ক্যাম্পেইন কোড](/bn/developer/api-reference/api-identifiers/#campaign-code) (বিকল্পভাবে, `application`, `messages_ids`, বা `message_codes` উল্লেখ করুন)।           |
| `messages_ids`     | হ্যাঁ      | Array   | মেসেজ আইডি (বিকল্পভাবে, `application`, `campaign`, বা `message_codes` উল্লেখ করুন)।                 |
| `link_template`    | আবশ্যক যদি `application` বা `campaign` উল্লেখ করা হয়।     | String  | কীওয়ার্ড দ্বারা ইমেইল লিঙ্ক ইন্টারঅ্যাকশন ফিল্টার করে। শুধুমাত্র সেই লিঙ্কগুলো API রেসপন্সে ফেরত আসবে যাদের URL-এ নির্দিষ্ট টেক্সট অন্তর্ভুক্ত আছে। উদাহরণস্বরূপ, যদি আপনার ইমেইলে `https://example.com/news` এবং `https://example.com/shop`-এর মতো লিঙ্ক থাকে, তবে "link_template": "shop" সেট করলে শুধুমাত্র `https://example.com/shop`-এর জন্য ইন্টারঅ্যাকশন ফেরত আসবে।   |
| `email_content_code`         | না       | String  | [ইমেইল কন্টেন্টের জন্য অনন্য শনাক্তকারী](/bn/developer/api-reference/api-identifiers/#email-content-code)।                                                                             |
| `page`            | না       | Integer | পেজিনেশনের জন্য পৃষ্ঠা নম্বর।                                                                         |
| `per_page`        | না       | Integer | প্রতি পৃষ্ঠায় ফলাফলের সংখ্যা (≤ 1000)।                                                                |

##### রিকোয়েস্টের উদাহরণ

```
curl --location --request POST 'https://api.pushwoosh.com/api/v2/statistics/emails/linksInteractionsDevices' \
--header 'Authorization: Api API_ACCESS_TOKEN' \
--header 'Content-Type: application/json' \
--data-raw '{
   "filters": {
      "date_range": {
         "date_from": "string",         // Required format: 2000-01-01
         "date_to": "string"            // Required format: 2000-01-01
      },
      "campaign": "string",             // Campaign code (you can specify application, messages_ids, or message_codes instead)
      "application": "string",          // Application code (you can specify campaign, messages_ids, or message_codes instead)
      "messages_ids": [],               // Message IDs (you can specify application, campaign, or message_codes instead)
      "messages_codes": [],             // Message codes (you can specify application, campaign, or message_ids instead)
      "link_template": "string",        // Link template (required if application or campaign is specified)
      "email_content_code": "string"    // Unique identifier for the email content.
   },
   "per_page": 100,
   "page": 0
}'
``` 

##### রেসপন্স কোড এবং উদাহরণ  
<Tabs>
<TabItem label="200: OK">
```json
{
  "total": 0,
  "items": [{
    "timestamp": "string",
    "link": "string",
    "hwid": "string"
  }]
}
```
</TabItem>

<TabItem label="400: Bad Request">
```json
{
  "error": "exceeded the maximum date interval. Max interval: 30 days"
}
```
</TabItem>

<TabItem label="401: Unauthorized">
```json
{
  "error": "account not found"
}
```
</TabItem>

<TabItem label="500: Internal Server Error">

</TabItem>
</Tabs>


### bouncedEmails

**POST** `https://api.pushwoosh.com/api/v2/statistics/emails/bouncedEmails`

ইমেইল অভিযোগ, সফট বাউন্স এবং হার্ড বাউন্স সম্পর্কিত ডেটা প্রদান করে, যার মধ্যে প্রতিটি বাউন্সের তারিখ, ইমেইল ঠিকানা এবং কারণ অন্তর্ভুক্ত থাকে।

##### অথরাইজেশন

রিকোয়েস্ট হেডারে API Access Token-এর মাধ্যমে অথরাইজেশন পরিচালনা করা হয়।

##### রিকোয়েস্ট বডি প্যারামিটার

| প্যারামিটারের নাম | ধরণ   | বিবরণ                                                                                      | আবশ্যক                                       |
|----------------|--------|--------------------------------------------------------------------------------------------------|------------------------------------------------|
| `application`  | string | [Pushwoosh অ্যাপ্লিকেশন কোড](/bn/developer/api-reference/api-identifiers/#application-code)                                                                             | হ্যাঁ                                            |
| `message_code` | string | [মেসেজ কোড](/bn/developer/api-reference/api-identifiers/#message-code)।                                                                                 | আবশ্যক যদি `date range` বা `campaign` প্রদান না করা হয়        |
| `campaign` | string | [ক্যাম্পেইন কোড](/bn/developer/api-reference/api-identifiers/#campaign-code)।    | আবশ্যক যদি `message_code` বা `date range` প্রদান না করা হয়        |
| `date_from`    | string | ডেটার শুরুর তারিখ `YYYY-MM-DDTHH:MM:SS.000Z` ফরম্যাটে (ISO 8601 স্ট্যান্ডার্ড)।         | আবশ্যক যদি `message_code` বা `campaign` প্রদান না করা হয়     |
| `date_to`      | string | ডেটার শেষ তারিখ `YYYY-MM-DDTHH:MM:SS.000Z` ফরম্যাটে (ISO 8601 স্ট্যান্ডার্ড)।           | আবশ্যক যদি `message_code` বা `campaign` প্রদান না করা হয়     |
| `per_page`     | int    | প্রতি পৃষ্ঠায় সারির সংখ্যা, সর্বোচ্চ ৫০০০।                                                        | হ্যাঁ                                            |
| `page`         | int    | পৃষ্ঠা নম্বর, শূন্য থেকে শুরু।                                                              | হ্যাঁ                                            |
| `type`         | string | বাউন্সের ধরণ: Complaint, Softbounce, Hardbounce।                                            | না                                             |

##### রিকোয়েস্টের উদাহরণ

```
{
  "application": "XXXXX-XXXXX",               // required. Pushwoosh app code
  "message_code": "XXXXX-XXXXXXXXX-XXXXXXXX", // required if campaign or date range is not provided.
                                              //          Unique message identifier
  "campaign": "XXXXX-XXXXX",                  // required if message_code or date range is not provided.
                                              //          Campaign code
  "date_from": "2024-07-20T00:00:00.000Z",    // required if message_code or campaign is not provided.
                                              //          Start date in ISO 8601 format "YYYY-MM-DDTHH:MM:SS.SSSZ"
  "date_to": "2024-07-20T00:00:00.000Z",      // required if message_code or campaign is not provided.
                                              //          End date in ISO 8601 format "YYYY-MM-DDTHH:MM:SS.SSSZ"
  "per_page": 1000,                           // required. Number of results per page, maximum 5000
  "page": 5,                                  // optional. Page number, starting from zero
  "type": "Softbounce"                        // optional. The type of bounce: Complaint, Softbounce, Hardbounce 
}

```

##### রেসপন্স ফিল্ডসমূহ

| ফিল্ডের নাম        | ধরণ   | বিবরণ                                                                 |
|-------------------|--------|-----------------------------------------------------------------------------|
| `total`           | int    | সারির মোট সংখ্যা।                                                    |
| `bounced_emails`  | array  | বাউন্স হওয়া ইমেইলের বিস্তারিত তথ্যের একটি অ্যারে।                                           |
| ├── `email`       | string | যে ইমেইল ঠিকানাটি বাউন্স হয়েছে।                                              |
| ├── `date`        | string | বাউন্সের তারিখ (ফরম্যাট: `YYYY-MM-DDTHH:MM:SS.000Z`)।                |
| ├── `reason`      | string | বাউন্সের কারণ।                                                   |
| └── `type`        | string | বাউন্সের ধরণ: Complaint, Softbounce, Hardbounce।                       |

##### রেসপন্সের উদাহরণ

```
{
  "total": 25,                             // Total count of rows.
  "bounced_emails": [{
    "email": "example@example.com",        // Email address that bounced
    "date": "2024-07-20T00:00:00.000Z",    // Bounce date in ISO 8601 format
    "reason": "Invalid recipient address", // Reason for the bounce
    "type": "Hardbounce"                   // Type of bounce: Complaint, Softbounce, Hardbounce
  }]
}
```